package main

import (
	"sort"
	"strconv"
	"strings"
)

func formatTokens(tokens []token) string {
	classes := map[string][]token{}

	for _, tokenItem := range tokens {
		className, ok := getClassName(tokenItem.key)
		if !ok {
			continue
		}

		parameterName, ok := getParameterName(tokenItem.key)
		if !ok {
			continue
		}

		_, classExist := classes[className]
		if !classExist {
			classes[className] = []token{}
		}

		tokenItem.paramName = parameterName
		classes[className] = append(classes[className], tokenItem)
	}

	return formatClasses(classes)
}

func formatClasses(classes map[string][]token) string {
	var keys []string
	for k := range classes {
		keys = append(keys, k)
	}

	sort.Strings(keys)

	result := "// Warning! This code is autogenerated by swift-l10n tool, don't make any changes to it\n"
	result += "// Source code of the tool is available here: https://gitlab.com/crosscone/swift-l10n\n\n"
	result += "import Foundation\n\n"
	result += "fileprivate func l(_ k: String) -> String { return NSLocalizedString(k, comment: \"\") }\n\nfinal class L10n {\n\n"

	for _, className := range keys {
		params := classes[className]

		result += "    final class " + className + " {\n"

		for _, param := range params {
			if param.paramsCount > 0 {
				result += "\n"
				result += `        /// Original string: ` + param.value + "\n"
				result += `        static func ` + param.paramName + `(`

				for i := 0; i < param.paramsCount; i++ {
					iStr := strconv.Itoa(i)
					result += `_ p` + iStr + `: String`

					if i < param.paramsCount-1 {
						result += ", "
					}
				}

				result += `) -> String { return String(format: l("` + param.key + `"), `

				for i := 0; i < param.paramsCount; i++ {
					iStr := strconv.Itoa(i)
					result += `p` + iStr

					if i < param.paramsCount-1 {
						result += ", "
					}
				}

				result += ") }\n"
			} else {
				result += "\n"
				result += `        /// Original string: ` + param.value + "\n"
				result += `        static let ` + param.paramName + ` = l("` + param.key + `")` + "\n"
			}
		}

		result += "\n    }\n\n"
	}

	result += "}\n"

	return result
}

func getClassName(key string) (string, bool) {
	i := strings.Index(key, ".")
	if i < 0 {
		return "", false
	}

	className := ""
	substrings := strings.Split(key[:i], "-")
	if len(substrings) == 0 {
		return "", false
	}

	for _, substring := range substrings {
		className += strings.Title(substring)
	}

	return className, true
}

func getParameterName(key string) (string, bool) {
	i := strings.Index(key, ".")
	if i < 0 {
		return "", false
	}

	capitalize := false

	parameterName := ""
	substrings := strings.Split(key[i+1:], "-")
	if len(substrings) == 0 {
		return "", false
	}

	for _, substring := range substrings {
		if capitalize {
			parameterName += strings.Title(substring)
		} else {
			parameterName += substring
			capitalize = true
		}
	}

	return parameterName, true
}
